unit T_BIANCOLOCK;

interface

uses
SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
Forms, Dialogs, ExtCtrls;

Type
  TFILLSTYLE=(fsNone,fsPixel,fsGrid,fsHorizontaalLine,fsVerticaalLine,fsRectangle,fsEllipse,fsText);
  TBiancoLock=class(TComponent)
  Private
   ScreenDC:HDC;
   fnt:TFont;
   F:TFORM;
   I:TIMAGE;
   Stri:String;
   DX,DY:INTEGER;
   GS:TFILLSTYLE;
   COL:TCOLOR;
   //PROCEDURE CAPTUREIMAGE(IMAGE1:TIMAGE);
   FUNCTION CAPTUREIMAGE:TBITMAP;
   PROCEDURE DO_P;
   PROCEDURE DO_VG;
   PROCEDURE DO_HL;
   PROCEDURE DO_VL;
   PROCEDURE DO_CI;
   PROCEDURE DO_RE;
   Procedure DO_te;
  Protected
  Public
   constructor Create(AOwner: TComponent); override;
   Destructor Destroy; Override;
   FUNCTION EXECUTE:BOOLEAN;
   PROCEDURE UNEXECUTE;
   //DRAWING METHODS
   FUNCTION LINE(X1,Y1,X2,Y2:INTEGER):BOOLEAN;
   FUNCTION PSET(X,Y:INTEGER):BOOLEAN;
   FUNCTION RECT(X1,Y1,X2,Y2:INTEGER):BOOLEAN;
//   FUNCTION CIRCLE(X1,Y1,X2,Y2:INTEGER):BOOLEAN;
   FUNCTION FILLRECT(X1,Y1,X2,Y2:INTEGER;FC:TCOLOR):BOOLEAN;
   FUNCTION FILLCIRCLE(X1,Y1,X2,Y2:INTEGER;FC:TCOLOR):BOOLEAN;
   FUNCTION Write(X1,Y1:INTEGER;S:String):BOOLEAN;
  Published
   PROPERTY Style:TFILLSTYLE READ GS WRITE GS;
   PROPERTY DeltaX:INTEGER READ DX WRITE DX;
   PROPERTY DeltaY:INTEGER READ DY WRITE DY;
   PROPERTY Color:TCOLOR READ COL WRITE COL;
   Property Text:String Read stri write stri;
   Property Font:TFont read fnt write fnt;
  end;

procedure Register;

implementation

//INTERNAL PROCEDURES
FUNCTION TBIANCOLOCK.CAPTUREIMAGE:TBITMAP;
 var
  newBitmap: TBitmap;
  IMAGE1:TIMAGE;
 begin
  newBitmap:=TBitmap.Create;
  try
   IMAGE1:=TIMAGE.CREATE(SELF);
   Image1.Picture.Graphic:=newBitmap;
   Image1.Picture.Graphic.Width:=SCREEN.WIDTH;
   Image1.Picture.Graphic.Height:=SCREEN.HEIGHT;
   try
    BitBlt(Image1.Picture.Bitmap.Canvas.Handle,
           0,0,SCREEN.WIDTH,SCREEN.HEIGHT,ScreenDC,0,0,SRCCOPY);
   finally
     //...
   end;
  Finally
   newBitmap.Free;
  end;
  RESULT:=IMAGE1.PICTURE.BITMAP;
 end;

PROCEDURE TBIANCOLOCK.DO_P;
 VAR
  X,Y:INTEGER;
 BEGIN
  //FILL WITH PIXELS
  WITH I DO
   BEGIN
    X:=0;
    REPEAT
     Y:=0;
     REPEAT
      INC(Y,DY);
      CANVAS.PIXELS[X,Y]:=COL;
     UNTIL Y>SCREEN.HEIGHT;
     INC(X,DX);
    UNTIL X>SCREEN.WIDTH;
   END;
 END;

PROCEDURE TBIANCOLOCK.DO_Te;
 VAR
  w,h,X,Y:INTEGER;

 BEGIN
  If stri='' then
   Exit;//Nothing to do
  //FILL WITH Text
  WITH I DO
   BEGIN
    Canvas.Font:=Fnt;
    Canvas.Font.Color:=Col;
    W:=Canvas.TextWidth(stri);
    H:=Canvas.TextHeight(stri);
    Canvas.Brush.Style:=bsClear;
    X:=0;
    REPEAT
     Y:=0;
     REPEAT
      CANVAS.TextOut(X,Y,Stri);
      INC(Y,H+dy);
     UNTIL Y>SCREEN.HEIGHT;
     INC(X,DX+W);
    UNTIL X>SCREEN.WIDTH;
   END;
 END;

PROCEDURE TBIANCOLOCK.DO_VG;
 VAR
  A:INTEGER;
 BEGIN
  //FILL WITH VERTICAAL GRID
  WITH I DO
   BEGIN
   CANVAS.PEN.COLOR:=COL;
    A:=0;
    REPEAT
     CANVAS.MOVETO(A,0);
     CANVAS.LINETO(A,SCREEN.HEIGHT);
     INC(A,DX);
    UNTIL A>SCREEN.WIDTH;
    A:=0;
    REPEAT
     CANVAS.MOVETO(0,A);
     CANVAS.LINETO(SCREEN.WIDTH,A);
     INC(A,DY);
    UNTIL A>SCREEN.HEIGHT;
   END;
 END;

PROCEDURE TBIANCOLOCK.DO_HL;
 VAR
  A:INTEGER;
 BEGIN
  //FILL WITH HORIZONTAL LINES
  WITH I DO
   BEGIN
    CANVAS.PEN.COLOR:=COL;
    A:=0;
    REPEAT
     CANVAS.MOVETO(0,A);
     CANVAS.LINETO(SCREEN.WIDTH,A);
     INC(A,DY);
    UNTIL A>SCREEN.HEIGHT;
   END;
 END;

PROCEDURE TBIANCOLOCK.DO_VL;
 VAR
  A:INTEGER;
 BEGIN
  //FILL WITH VERTICAAL LINES
  WITH I DO
   BEGIN
    CANVAS.PEN.COLOR:=COL;
    A:=0;
    REPEAT
     CANVAS.MOVETO(A,0);
     CANVAS.LINETO(A,SCREEN.HEIGHT);
     INC(A,DX);
    UNTIL A>SCREEN.WIDTH;
   END;
 END;

PROCEDURE TBIANCOLOCK.DO_RE;
 VAR
  X,Y:INTEGER;
 BEGIN
  //FILL WITH RECTANGLES
  WITH I DO
   BEGIN
    CANVAS.PEN.COLOR:=COL;
    CANVAS.BRUSH.COLOR:=COL;
    X:=0;
    REPEAT
     Y:=0;
     REPEAT
      CANVAS.RECTANGLE(X,Y,X+DX,Y+DY);
      INC(Y,DY*2);
     UNTIL Y>SCREEN.HEIGHT;
     INC(X,DX*2);
    UNTIL X>SCREEN.WIDTH;
   END;
 END;

PROCEDURE TBIANCOLOCK.DO_CI;
 VAR
  X,Y:INTEGER;
 BEGIN
  //FILL WITH CIRCLES
  WITH I DO
   BEGIN
    CANVAS.PEN.COLOR:=COL;
    CANVAS.BRUSH.COLOR:=COL;
    X:=0;
    REPEAT
     Y:=0;
     REPEAT
      CANVAS.ELLIPSE(X,Y,X+DX,Y+DY);
      INC(Y,DY*2);
     UNTIL Y>SCREEN.HEIGHT;
     INC(X,DX*2);
    UNTIL X>SCREEN.WIDTH;
   END;
 END;

//METHODS
FUNCTION TBIANCOLOCK.EXECUTE:BOOLEAN;
 BEGIN
  IF F=NIL THEN
   BEGIN
    ScreenDC := GetDC(0);
    F:=TFORM.CREATE(SELF);
    I:=TIMAGE.CREATE(SELF);
    WITH I DO
     BEGIN
      PARENT:=F;
      TOP:=0;
      LEFT:=0;
      WIDTH:=SCREEN.WIDTH;
      HEIGHT:=SCREEN.HEIGHT;
      PICTURE.ASSIGN(CAPTUREIMAGE);
     END;
    F.BORDERICONS:=[];
    F.BORDERSTYLE:=BSNONE;
    F.TOP:=0;
    F.LEFT:=0;
    F.WIDTH:=SCREEN.WIDTH;
    F.HEIGHT:=SCREEN.HEIGHT;
//    F.CURSOR:=crHourGlass;
    F.SHOW;
    F.UPDATE;
//    APPLICATION.PROCESSMESSAGES;
    LockWindowUpdate(f.canvas.handle);
    CASE GS OF
     fsNone:BEGIN
             //NOTHING TO DO
            END;
     fsPixel:DO_P;
     fsGrid:DO_VG;
     fsEllipse:DO_CI;
     fsHorizontaalLine:DO_HL;
     fsVerticaalLine:DO_VL;
     fsRectangle:DO_RE;
     fsText:DO_Te;
    END;
    LockWindowUpdate(0);
    ReleaseDC(0,ScreenDC);
    RESULT:=TRUE;
   END
  ELSE
   RESULT:=FALSE;
 END;

PROCEDURE TBIANCOLOCK.UNEXECUTE;
 BEGIN
  IF F<>NIL THEN
   BEGIN
    I.FREE;
    F.CLOSE;
    F.FREE;
    F:=NIL;
   END;
 END;

//DRAWING METHODS

FUNCTION TBIANCOLOCK.LINE(X1,Y1,X2,Y2:INTEGER):BOOLEAN;
 BEGIN
  IF F<>NIL THEN
   BEGIN
    WITH I DO
     BEGIN
      CANVAS.PEN.COLOR:=COL;
      CANVAS.MOVETO(X1,Y1);
      CANVAS.LINETO(X2,Y2);
     END;
    RESULT:=TRUE;
   END
  ELSE
   RESULT:=FALSE;
 END;

FUNCTION TBIANCOLOCK.Write(X1,Y1:INTEGER;S:String):BOOLEAN;
 BEGIN
  IF F<>NIL THEN
   BEGIN
    WITH I DO
     BEGIN
      Canvas.Font:=Fnt;
      Canvas.Font.Color:=Col;
      Canvas.Brush.Style:=bsClear;
      CANVAS.TextOut(X1,Y1,S);
     END;
    RESULT:=TRUE;
   END
  ELSE
   RESULT:=FALSE;
 END;

FUNCTION TBIANCOLOCK.PSET(X,Y:INTEGER):BOOLEAN;
 BEGIN
  IF F<>NIL THEN
   BEGIN
    I.CANVAS.PIXELS[X,Y]:=COL;
    RESULT:=TRUE;
   END
  ELSE
   RESULT:=FALSE;
 END;

FUNCTION TBIANCOLOCK.RECT(X1,Y1,X2,Y2:INTEGER):BOOLEAN;
 BEGIN
  IF F<>NIL THEN
   BEGIN
    WITH I DO
     BEGIN
      CANVAS.PEN.COLOR:=COL;
      CANVAS.MOVETO(X1,Y1);
      CANVAS.LINETO(X2,Y1);
      CANVAS.LINETO(X2,Y2);
      CANVAS.LINETO(X1,Y2);
      CANVAS.LINETO(X1,Y1);
     END;
    RESULT:=TRUE;
   END
  ELSE
   RESULT:=FALSE;
 END;

//FUNCTION TBIANCOLOCK.CIRCLE(X1,Y1,X2,Y2:INTEGER):BOOLEAN;
FUNCTION TBIANCOLOCK.FILLRECT(X1,Y1,X2,Y2:INTEGER;FC:TCOLOR):BOOLEAN;
 BEGIN
  IF F<>NIL THEN
   BEGIN
    WITH I DO
     BEGIN
      CANVAS.PEN.COLOR:=COL;
      CANVAS.BRUSH.COLOR:=FC;
      CANVAS.RECTANGLE(X1,Y1,X2,Y2);
     END;
    RESULT:=TRUE;
   END
  ELSE
   RESULT:=FALSE;
 END;


FUNCTION TBIANCOLOCK.FILLCIRCLE(X1,Y1,X2,Y2:INTEGER;FC:TCOLOR):BOOLEAN;
 BEGIN
  IF F<>NIL THEN
   BEGIN
    WITH I DO
     BEGIN
      CANVAS.PEN.COLOR:=COL;
      CANVAS.BRUSH.COLOR:=FC;
      CANVAS.ELLIPSE(X1,Y1,X2,Y2);
     END;
    RESULT:=TRUE;
   END
  ELSE
   RESULT:=FALSE;
 END;

//*****************************************************************************
Constructor TBiancoLock.Create(AOwner: TComponent);
 Begin
  Inherited Create(Aowner);
  fnt:=Tfont.Create;
  DX:=2;
  DY:=2;
//  RANDOMIZE;
//  IF RANDOM(5)=0 THEN
//   SHOWMESSAGE('Bianchini Marco'+#13+'E-Mail bianco@arcanet.it');
 End;

Destructor TBiancoLock.Destroy;
 Begin
  fnt.Free;
  Inherited Destroy;
 End;

procedure Register;
 begin
  RegisterComponents('Bianco', [TBiancoLock]);
 end;

end.

